import logging
from datetime import datetime
from grabber import Grabber


class BBCTechnology(Grabber):
    feed_url = "http://feeds.bbci.co.uk/news/technology/rss.xml"
    date_format = "%a, %d %b %Y %H:%M:%S %Z"

    def parse(self, feed):
        articles = []
        for article in feed.iter("item"):
            try:
                # Fri, 17 Jan 2020 19:09:40 GMT
                timestamp = int(datetime.strptime(article.find("pubDate").text, self.date_format).timestamp())
                title = article.find("title").text
                description = article.find("description").text
                articles.append((timestamp, title, description))
            except AttributeError:
                logging.error(f"Received non-parsable news article from {self.name}.")
        return articles


